config/routes.rb
Rails.application.routes.draw do
  if Rails.env.development?
    mount GraphiQL::Rails::Engine, at: "/graphiql", graphql_path: "/graphql"
  end
  post "/graphql", to: "graphql#execute"

  root to: "pages#home"
  get 'source_code', to: "pages#source_code"
  get 'who-am-i',    to: "pages#who_am_i"
  
  namespace :api, defaults: { format: :json } do
    resources :quotes, only: [ :show ]
    resources :images, only: [ :show ]
  end

  resources :stocks, only: [:show, :index]
  resources :quotes, only: [:index, :show]
  resources :memes,  only: [:index]
  resources :images, only: [:create, :index, :show]
  resources :sites do 
    collection do 
      get :login
      post :login
      get :signup
      post :signup
      get :logout
    end
  end
end

app/models/uptime_monitor/site.rb
module UptimeMonitor
  class Site < ApplicationRecord
    validates_presence_of :name, :url

    belongs_to :user, class_name: 'UptimeMonitor::User', foreign_key: 'user_id'

    def status
      up? ? 'UP' : 'DOWN'
    end
  end
end

app/controllers/sites_controller.rb
class SitesController < ApplicationController
  skip_before_action :verify_authenticity_token
  before_action :check_if_logged_in, except: [:index, :login, :signup]
  before_action :set_heading

  def index
    if logged_in?
      @sites = current_user.sites
    else
      @sites = UptimeMonitor::Site.none
    end
  end

  def new
    @site = UptimeMonitor::Site.new
  end

  def edit
    @site = UptimeMonitor::Site.find(params[:id])
  end

  def update
    @site = UptimeMonitor::Site.find(params[:id])

    if @site.update_attributes(site_params)
      redirect_to sites_path
    else
      render 'edit'
    end
  end

  def create
    @site = current_user.sites.new(site_params)
  
    if @site.save
      redirect_to sites_path
    else
      render 'new'
    end
  end

  def destroy
    @site = UptimeMonitor::Site.find(params[:id])
    @site.destroy

    redirect_to sites_path
  end

  def login
    if request.get?
      @user = UptimeMonitor::User.new
    else
      do_login
    end
  end

  def signup
    if request.get?
      @user = UptimeMonitor::User.new
    else
      do_signup
    end
  end

  def logout
    cookies[:auth_token] = ""
    redirect_to login_sites_path
  end

  private

  def do_login
    @user =UptimeMonitor::User.where(email: params[:uptime_monitor_user][:email]).first

    if @user && @user.valid_password?(params[:uptime_monitor_user][:password])
      set_current_user(@user)
      redirect_to sites_path
    else
      flash[:error_display] = "message-visible"
      flash[:message]       = "Email/Password does not match" 

      redirect_to login_sites_path
    end
  end

  def do_signup
    @user = UptimeMonitor::User.new(user_params)
  
    if @user.save
      flash[:success_display] = "message-visible"
      flash[:message] = "Registration completed. Please login to continue"
      redirect_to login_sites_path
    else
      flash[:error_display] = "message-visible"
      flash[:message] = "Signup Failed" 

      render 'signup'
    end
  end

  def site_params
    params.require(:uptime_monitor_site).permit(:name, :url)
  end

  def user_params
    params.require(:uptime_monitor_user).permit(:name, :email, :password)
  end

  private

  def check_if_logged_in
    unless logged_in?
      flash[:message] = "Please login or signup to continue"
      redirect_to login_sites_path
    end
  end

  def logged_in?
    current_user.present?
  end

  def current_user
    @_current_user ||= UptimeMonitor::User.where(auth_token: cookies[:auth_token]).first 
  end

  helper_method :current_user, :logged_in?

  def set_current_user(user)
    cookies[:auth_token] = user.auth_token
    @_current_user = user
  end

  def set_heading
    p cookies[:auth_token]
    @heading = "Uptime Monitor"
    flash[:success_display] = "message-hidden" unless flash[:success_display].present?
    flash[:error_display]   = "message-hidden" unless flash[:error_display].present?
  end
end

app/views/sites/_fields.html.erb
<div class="form-group">
  <%= f.label :name %>
  <%= f.text_field :name, class: 'form-control' %>
</div>

<div class="form-group">
  <%= f.label :url %>
  <%= f.text_field :url, class: 'form-control' %>
</div>

app/views/sites/_messages.html.erb
<div class="alert alert-success <%= flash[:success_display] %>">
  <%= flash[:message] %>
</div>

<div class="alert alert-danger <%= flash[:error_display] %>">
  <%= flash[:message] %>
</div>

app/views/sites/edit.html.erb
<section class="portfolio" id="portfolio">
  <div class="container">
    <div class="row">
      <div class="col-md-8 col-lg-8">
        <h5>Edit site</h5>
        <hr/>
        <%= form_for @site, url: site_path(@site), method: :put, html: {class: "form"} do |f| %>
          <%= render partial: 'fields', locals: {f: f} %>

          <div class="form-group">
            <%= f.submit "Update", class: 'btn btn-primary' %>
          </div>
        <% end %>
      </div>
    </div>
  </div>
</section>

app/views/sites/index.html.erb
<section class="portfolio" id="portfolio">
  <div class="container">
    <div class="row">
      <div class="col-md-8 col-lg-8">
        <% if logged_in? %>
          <div class="row">
            <div class="col-md-12 col-lg-12 alert alert-success %>">
                Welcome, <%= current_user.name %> 
            </div>
          </div>
        <% end %>

        <div class="row mb-4">
          <div class="col-md-6 col-lg-6">
            <h3> Monitored Sites</h3>
          </div>
          <div class="col-md-6 col-lg-6">
            <div class="float-right">
              <%= link_to 'Add new site', new_site_path, class: 'btn btn-primary'%>
              <%= link_to 'Logout', logout_sites_path, class: 'btn btn-secondary'%>
            </div>
          </div>
        </div>
        <table class="table">
          <thead>
            <th>Name</th>
            <th>URL</th>
            <th>Status</th>
            <th>Last Checked</th>
            <th>#</th>
          </thead>

          <tbody>
            <% @sites.each do |site| %>
            <tr class="<%= site.up? ? '' : 'btn-secondary' %>">
              <td><%= site.name %></td>
              <td><%= link_to site.url, site.url, target: '_blank' %></td>
              <td><%= site.status %></td>
              <td><%= site.updated_at.strftime("%B %d %Y, %H:%M:%S") %></td>
              <td><%= link_to 'edit', edit_site_path(site) %> | <%= link_to 'delete', site_path(site), data: {confirm: 'Are you sure?', method: :delete} %></td>
            </tr>
            <% end %>
          </tbody>
        </table>
      </div>
    </div>
  </div>
</section>

app/views/sites/login.html.erb
<% content_for :head do %>
  <%= stylesheet_link_tag 'sites' %>
<% end %>

<section class="portfolio" id="portfolio">
  <div class="container">
    <div class="row">
      <div class="col-md-8 col-lg-8">
        <h5>Login to Uptime Monitor or <%= link_to "Signup", signup_sites_path %></h5>
        <hr/>

        <%= render partial: 'messages' %>

        <div class="border p-4">
          <%= form_for @user, url: '', method: :post, html: {class: "form"} do |f| %>
            <div class="form-group">
              <%= f.label :email %>
              <%= f.text_field :email, class: 'form-control' %>
            </div>

            <div class="form-group">
              <%= f.label :password %>
              <%= f.password_field :password, class: 'form-control' %>
            </div>

            <div class="form-group">
              <%= f.submit "Login", class: 'btn btn-primary' %>
            </div>
          <% end %>
        </div>
      </div>
    </div>
  </div>
</section>

app/views/sites/new.html.erb
<section class="portfolio" id="portfolio">
  <div class="container">
    <div class="row">
      <div class="col-md-8 col-lg-8 border p-4">
        <h5>Add new site to monitor</h5>
        <hr/>
        <%= form_for @site, url: sites_path, method: :post, html: {class: "form"} do |f| %>
          <%= render partial: 'fields', locals: {f: f} %>

          <div class="form-group">
            <%= f.submit "Save", class: 'btn btn-primary' %>
          </div>
        <% end %>
      </div>
    </div>
  </div>
</section>

app/views/sites/signup.html.erb
<% content_for :head do %>
  <%= stylesheet_link_tag 'sites' %>
<% end %>

<section class="portfolio" id="portfolio">
  <div class="container">
    <div class="row">
      <div class="col-md-8 col-lg-8">
        <h5>Signup for Uptime Monitor</h5>
        <hr/>

        <%= render partial: 'messages' %>

        <div class="border p-4">
          <%= form_for @user, url: '', method: :post, html: {class: "form"} do |f| %>
            <div class="form-group">
              <%= f.label :name %>
              <%= f.text_field :name, class: 'form-control' %>
            </div>

            <div class="form-group">
              <%= f.label :email %>
              <%= f.text_field :email, class: 'form-control' %>
            </div>

            <div class="form-group">
              <%= f.label :password %>
              <%= f.password_field :password, class: 'form-control' %>
            </div>

            <div class="form-group">
              <%= f.submit "Signup", class: 'btn btn-primary' %>
            </div>
          <% end %>
        </div>
      </div>
    </div>
  </div>
</section>